<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:12 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ComponentMetadataHandler (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ComponentMetadataHandler (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/gradle/api/artifacts/dsl/ArtifactHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" target="_top">Frames</a></li>
<li><a href="ComponentMetadataHandler.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.artifacts.dsl</div>
<h2 title="Interface ComponentMetadataHandler" class="title">Interface ComponentMetadataHandler</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">ComponentMetadataHandler</span></pre>
<div class="block">Allows the build to provide rules that modify the metadata of depended-on software components.

 <p>Possible uses of component metadata rules are:
 <ul>
     <li>Setting the status and status scheme of a component, overriding the value specified in the component descriptor.</li>
     <li>Declaring whether or not a component is 'changing', thus impacting the cache behaviour of the component.</li>
 </ul>

 <p> Example:
 <pre class='autoTested'>
 dependencies {
     components {
         // Set the status and status scheme for every component belonging to a module in the group "org.foo"
         all { ComponentMetadataDetails details -&gt;
             if (details.id.group == "org.foo") {
                 def version = details.id.version
                 // assuming status is last part of version string
                 details.status = version.substring(version.lastIndexOf("-") + 1)
                 details.statusScheme = ["bronze", "silver", "gold", "platinum"]
             }
         }

         // Treat all components in the module "org.foo:bar" as changing
         withModule("org.foo:bar") { ComponentMetadataDetails details -&gt;
             details.changing = true
         }
     }
 }
 </pre></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.8</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#all(org.gradle.api.Action)">all</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/ComponentMetadataDetails.html" title="interface in org.gradle.api.artifacts">ComponentMetadataDetails</a>&gt;&nbsp;rule)</code>
<div class="block">Adds a rule action that may modify the metadata of any resolved software component.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#all(groovy.lang.Closure)">all</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&lt;?&gt;&nbsp;rule)</code>
<div class="block">Adds a rule closure that may modify the metadata of any resolved software component.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#all(java.lang.Object)">all</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;ruleSource)</code>
<div class="block">Adds a rule that may modify the metadata of any resolved software component.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#withModule(java.lang.Object,%20org.gradle.api.Action)">withModule</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;id,
          <a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/ComponentMetadataDetails.html" title="interface in org.gradle.api.artifacts">ComponentMetadataDetails</a>&gt;&nbsp;rule)</code>
<div class="block">Adds a rule that may modify the metadata of any resolved software component belonging to the specified module.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#withModule(java.lang.Object,%20groovy.lang.Closure)">withModule</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;id,
          <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&lt;?&gt;&nbsp;rule)</code>
<div class="block">Adds a rule that may modify the metadata of any resolved software component belonging to the specified module.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#withModule(java.lang.Object,%20java.lang.Object)">withModule</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;id,
          <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;ruleSource)</code>
<div class="block">Adds a rule that may modify the metadata of any resolved software component belonging to the specified module.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="all(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>all</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;all(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/ComponentMetadataDetails.html" title="interface in org.gradle.api.artifacts">ComponentMetadataDetails</a>&gt;&nbsp;rule)</pre>
<div class="block">Adds a rule action that may modify the metadata of any resolved software component.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>rule</code> - the rule to be added</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="all(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>all</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;all(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&lt;?&gt;&nbsp;rule)</pre>
<div class="block">Adds a rule closure that may modify the metadata of any resolved software component.

 <p>The supplied rule closure must declare a <a href="../../../../../org/gradle/api/artifacts/ComponentMetadataDetails.html" title="interface in org.gradle.api.artifacts"><code>ComponentMetadataDetails</code></a> as it's first parameter,
 allowing the component metadata to be modified.

 <p>In addition, the rule can declare additional (read-only) parameters, which may provide extra details
 about the component. The order of these additional parameters is not significant.

 <p>The following additional parameter types are supported:
 <ul>
     <li><a href="../../../../../org/gradle/api/artifacts/ivy/IvyModuleDescriptor.html" title="interface in org.gradle.api.artifacts.ivy"><code>IvyModuleDescriptor</code></a> - additional Ivy-specific
     metadata. Rules declaring this parameter will only be invoked for components packaged as an Ivy module.</li>
 </ul></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>rule</code> - the rule to be added</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="all(java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>all</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;all(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;ruleSource)</pre>
<div class="block">Adds a rule that may modify the metadata of any resolved software component.

 <p>The ruleSource is an Object that has a single rule method annotated with <a href="../../../../../org/gradle/model/Mutate.html" title="annotation in org.gradle.model"><code>Mutate</code></a>.

 <p>This rule method:
 <ul>
     <li>must return void.</li>
     <li>must have <a href="../../../../../org/gradle/api/artifacts/ComponentMetadataDetails.html" title="interface in org.gradle.api.artifacts"><code>ComponentMetadataDetails</code></a> as the first parameter.</li>
     <li>may have an additional parameter of type <a href="../../../../../org/gradle/api/artifacts/ivy/IvyModuleDescriptor.html" title="interface in org.gradle.api.artifacts.ivy"><code>IvyModuleDescriptor</code></a>.</li>
 </ul></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>ruleSource</code> - the rule source object to be added</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="withModule(java.lang.Object, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>withModule</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;withModule(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;id,
                                  <a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/ComponentMetadataDetails.html" title="interface in org.gradle.api.artifacts">ComponentMetadataDetails</a>&gt;&nbsp;rule)</pre>
<div class="block">Adds a rule that may modify the metadata of any resolved software component belonging to the specified module.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>id</code> - the module to apply this rule to in "group:module" format or as a <a href="../../../../../org/gradle/api/artifacts/ModuleIdentifier.html" title="interface in org.gradle.api.artifacts"><code>ModuleIdentifier</code></a></dd><dd><code>rule</code> - the rule to be added</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="withModule(java.lang.Object, groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>withModule</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;withModule(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;id,
                                  <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&lt;?&gt;&nbsp;rule)</pre>
<div class="block">Adds a rule that may modify the metadata of any resolved software component belonging to the specified module.

 <p>The rule closure parameter is subject to the same requirements as <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#all(groovy.lang.Closure)"><code>all(groovy.lang.Closure)</code></a>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>id</code> - the module to apply this rule to in "group:module" format or as a <a href="../../../../../org/gradle/api/artifacts/ModuleIdentifier.html" title="interface in org.gradle.api.artifacts"><code>ModuleIdentifier</code></a></dd><dd><code>rule</code> - the rule to be added</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="withModule(java.lang.Object, java.lang.Object)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>withModule</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;withModule(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;id,
                                  <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;ruleSource)</pre>
<div class="block">Adds a rule that may modify the metadata of any resolved software component belonging to the specified module.

 <p>The rule source parameter is subject to the same requirements as <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html#all(java.lang.Object)"><code>all(Object)</code></a>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>id</code> - the module to apply this rule to in "group:module" format or as a <a href="../../../../../org/gradle/api/artifacts/ModuleIdentifier.html" title="interface in org.gradle.api.artifacts"><code>ModuleIdentifier</code></a></dd><dd><code>ruleSource</code> - the rule source object to be added</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/gradle/api/artifacts/dsl/ArtifactHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" target="_top">Frames</a></li>
<li><a href="ComponentMetadataHandler.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
